/*
 *  main.c
 *  Stereo_Video
 *
 *  Created by David Sweet on 7/16/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "../StereoVideoLib/SingleImage.h"
#include "../StereoVideoLib/FrameData.h"
#include "../StereoVideoLib/StereoVideo.h"


//store image processing results here
SingleImage *pLeft, *pRight;
FrameData *pFLeft, *pFRight;

/**
* Calculate the intensity of an image.
 **/
void mkIntensity(struct FrameData *pFrameData, SingleImage *pSingleImage)
{
	
	// This function demonstrates pixel addressing.
	
	ImageBuffer *buffer = &pFrameData->buffer;
	
	int row, col, irow, irgba, ii;
	int nrows = buffer->bounds.bottom - buffer->bounds.top;
	int ncols = buffer->bounds.right - buffer->bounds.left;
	
	
	int ncols4 = 4*ncols;
	for (row=0; row<nrows; row++)
	  {
		
		irow = (16 + ncols4)*row;
		for (col=0; col<ncols; col++)
		  {
			int x=0;
			ii=irow + col*4;
			
			for (irgba=1; irgba<4; irgba++)  // "irgba<2" ==> only RGB, not A
			  {
				x+=buffer->buffer[ii + irgba];
			  }
			
			x /= 3;  // intensity is avg. of RGB
			
			for (irgba=1; irgba<4; irgba++)
			  {
				pSingleImage->buffer.buffer[ii+irgba] = x;
			  }
			
			pSingleImage->buffer.buffer[ii] = 255; // A, alpha channel
			
		  }
	  }
	
	
	
}







void processFrames(FrameData *pFrameDataLeft, FrameData *pFrameDataRight, bool bAB)
{
	
	/**
	
	 Process the two frames pAllData->pFrameDataL and pAllData->pFrameDataR.
	 
	 **/
	
	// TODO: provide example of stock DP algorithm
	
	pFLeft = pFrameDataLeft;
	pFRight = pFrameDataRight;
	
	mkIntensity(pFrameDataLeft, pLeft);
	mkIntensity(pFrameDataRight, pRight);
	
}


void drawFrames(bool bDiagnostic, bool bAB)
{
	
	// textures are 32 x 24
	
	if (bDiagnostic)
	  {
		
		// Display any diagnostic video here
		
		
		// For example: Display raw and processed frames together.
		// Notice that the left/right coordinates (31, 16) are in decreasing order in these calls.
		// The effects a reflection giving a mirror image as output.
		StereoVideo_displayImage(pFLeft->texture, &pFLeft->buffer, 31, 16, 12, 23);
		StereoVideo_displayImage(pFRight->texture, &pFRight->buffer, 15, 0, 12, 23);
		
		StereoVideo_displayImage(pLeft->texture, &pLeft->buffer, 31, 16, 0, 12);
		StereoVideo_displayImage(pRight->texture, &pRight->buffer, 15, 0, 0, 12);
	  }		
	else
	  {
		// Display your "final product" only.
		
		StereoVideo_displayImage(pLeft->texture, &pLeft->buffer, 31, 16, 0, 23);
		StereoVideo_displayImage(pRight->texture, &pRight->buffer, 15, 0, 0, 23);
		
	  }
	
	
}






int
main()
{
	printf ("main\n");
	
	StereoVideo s;
	s.processFrames = processFrames;
	s.drawFrames = drawFrames;
	
	if (StereoVideo_construct(&s)!=noErr)
	  {
		fprintf(stderr, "Error initializing StereoVideo\n");
		exit(1);
	  }
	
	pLeft = SingleImage_construct();
	pRight = SingleImage_construct();
	
	
    // Run the Carbon event loop.
    RunApplicationEventLoop();
    return 0;
	
}